#!/bin/sh

. /tmp/openit-cfg-shenv

LIBEXEC="$ROOT_DIR/libexec"
ARCH=""

if grep -Fq -e "session.save_path" "/etc$ROOT_DIR/php.ini"
then
    echo "/etc$ROOT_DIR/php.ini doesn't need updating, skipping."
else
	#Get the first three part of the version
	ver3=`grep VERSION $ROOT_TEMP_DIR/inst/package/accserver.info | cut -d" " -f2 | cut -d "." -f 1-3 | tr -d '.'`

	#If the first three part is less than 6.3.0
	if [ $ver3 -lt 630 ]; then
		printf "%b" "\n  session.save_path=$TEMP_DIR" >> "/etc$ROOT_DIR/php.ini"
	fi
fi

if [ `uname` = "Linux" ]; then
	#Set the memory_limit to max
	sed -i 's/memory_limit=.*/memory_limit=-1/' "/etc$ROOT_DIR/php.ini"
	
	#Set the Timeout to 10 hours
	sed -i 's/Timeout 14400/Timeout 36000/' "$CONFIG_DIR/httpd/httpd.conf"

	#Copy the new php binary
	if [ `uname -p` = "i686" ]; then
		cp files/php32b "$LIBEXEC/i686-redhat-linux/bin/php"
		cp files/ixed.5.6-32b.lin "$LIBEXEC/i686-redhat-linux/lib/ixed.5.6.lin"

		# Check if the Source Guardian loader for 32-bit architecture was already exist in php.ini file
		if grep -Fq "ixed.5.6.lin" "/etc$ROOT_DIR/php.ini"
		then
			echo "/etc$ROOT_DIR/php.ini doesn't need updating, skipping."
		    exit 0
		else
		    printf "%b" "\n  extension=$LIBEXEC/i686-redhat-linux/lib/ixed.5.6.lin" >> "/etc$ROOT_DIR/php.ini"
		    exit 0
		fi
	else
		cp files/php64b "$LIBEXEC/x86_64-unknown-linux/bin/php"
		cp files/ixed.5.6-64b.lin "$LIBEXEC/x86_64-unknown-linux/lib/ixed.5.6.lin"

		# Check if the Source Guardian loader for 64-bit architecture was already exist in php.ini file
		if grep -Fq "ixed.5.6.lin" "/etc$ROOT_DIR/php.ini"
		then
			echo "/etc$ROOT_DIR/php.ini doesn't need updating, skipping."
		    exit 0
		else
		    printf "%b" "\n  extension=$LIBEXEC/x86_64-unknown-linux/lib/ixed.5.6.lin" >> "/etc$ROOT_DIR/php.ini"
		    exit 0
		fi
	fi
fi


